#!/bin/sh 

if [ "$BUILD_NUMBER" = "" ]; then 
   echo "BUILD_NUMBER environment variable was not specified" >&2
   echo "USAGE:" >&2
   echo "   env BUILD_NUMBER=123 $0 [<branch>]" >&2
   exit 1
fi

BRANCH=trunk
if [ -n "$1" ]; then
	BRANCH="branches/$1"
fi

set -e

svn co --depth files https://svn.parallels.com/parallels/platform/webgate/${BRANCH} webgate
#trying to escape a single quot - this is the reason of the quotes hell
export MAJOR_VERSION=`perl -n -e 'm/^SKIN_VERSION\s*=\s*'"'"'(\d+?.\d+?)/ && print $1;' webgate/wscript`
export VERSION="${MAJOR_VERSION}.${BUILD_NUMBER}"
export OREV=`perl -n -e 'if (m/^\s*SKIN_REVISION\s*=\s*'"'"'(\d+?)'"'"'/) { print $1; }' webgate/wscript`
export NREV=`svnversion | perl -p -e 's/[A-Z]//g; s/\d+://g';`

echo VERSION = $VERSION
echo "Changes: $OREV -> $NREV"

if [ "$NREV" -gt "$OREV" ]; then	
	echo test2
	log=`svn -r$OREV:$NREV log | perl -p -e '$_ = ". $_";'`	
	echo test3
fi

perl -pi -e 's/(^SKIN_VERSION\s*=\s*'"'"')\S+?('"'"'\s*)$/$1$ENV{VERSION}$2/;
			 s/(^SKIN_REVISION\s*=\s*'"'"')\S+?('"'"'\s*)$/$1$ENV{NREV}$2/' webgate/wscript

svn diff webgate/wscript


if [ `echo "$log" | wc -l` -gt 1 ]; then
	msg="
		
$log"
	echo "ui runtime log: $msg"
fi

svn ci --username $SVN_USER --password $SVN_PASSWORD --non-interactive  --no-auth-cache -m "AUTO - bump ppanel-theme requirement in WebGate ppanel-theme-$VERSION" \
	webgate/wscript