<?php

class BuySupportPackAction extends PurchaseSupportAction {

    protected function _getPlanId(SimpleXMLElement $keyInfo)
    {
        $mapping = sfConfig::get('app_sp', array());
        $keyType = (string)$keyInfo->xpath('member[name="apiKeyType"]/value/text()')[0];

        $susAndSupportInfo = $keyInfo->xpath('member[name="susAndSupportInfo"]/value/array/data')[0];
        $expirationDate = (string)$susAndSupportInfo->xpath('value/struct[member[name="supportIncidents"]]/member[name="expiration"]/value/dateTime.iso8601/text()')[0];
        if (!$expirationDate) {
            throw new InputException('TRANS_ORDERFORM_SP_NOT_APPLICABLE_TO_LICENSE');
        }
        $planType = new DateTime($expirationDate, new DateTimeZone('UTC')) > new DateTime('now', new \DateTimeZone('UTC')) ? self::TYPE_RENEW : self::TYPE_REINSTATE;

        foreach ($mapping[$planType] as $planId => $types) {
            if (in_array($keyType, $types)) {
                $isProblem = (int)$keyInfo->xpath('member[name="problem"]/value/boolean/text()')[0];
                $isTerminated = (int)$keyInfo->xpath('member[name="terminated"]/value/boolean/text()')[0];
                if ($isProblem || $isTerminated) {
                    throw new InputException('TRANS_ORDERFORM_SP_INACTIVE_LICENSE');
                }
                return $planId;
            }
        }

        throw new InputException('TRANS_ORDERFORM_SP_INAPPROPRIATE_KEY_TYPE');
    }
}
